%define build_wb 1
%define build_mt 0

# pkgconfig file name
%define gtkhtml  libgtkhtml-3.14

# FIXME:
#%define jarch %(echo %_arch | sed -e s/x86_64/amd64/ -e s/i.86/i386/)
#%define javaincdir /usr/java/jdk1.6.0/include/
#%define javalibdir /usr/java/jdk1.6.0/jre/lib/%jarch/server

Name: mysql-gui-tools
Version: 5.0r17
Release: alt0.M51.2

Summary: GUI Tools for MySQL 5.0

Url: http://www.mysql.com/products/tools/
Group: Development/Databases
License: GPLv2+

Packager: Evgeny Sinelnikov <sin@altlinux.ru>

# direct link is not exists due mirrors
# http://dev.mysql.com/get/Downloads/MySQLGUITools/mysql-gui-tools-5.0r12.tar.gz/from/http://mysql.directnet.ru/
# SVN from http://dev.mysql.com/tech-resources/sources.html
Source: %name-%version.tar

#http://downloads.mysql.com/docs/guibook-en.html-chapter.tar.gz
Source1: guibook-en.html-chapter.tar

Patch0: %name-5.0r12-DEBUG.patch
Patch1: mysql-query-browser-default_schema_infinite_loop.patch
Patch2: %name-5.0_p12-gcc-4.3.patch
Patch3: %name-5.0_p12-libsigc++-2.2.patch
Patch4: %name-gtksourceview-cflags.patch
Patch5: %name-5.0r14-common.patch
Patch6: gtk_deprecated_typedefs.patch
Patch7: %name-5.0r17-common-cleanup.patch
Patch8: %name-lua.patch
Patch9: %name-python.patch
Patch10: %name-termcap.patch
Patch11: %name-mycnf.patch

BuildRequires: gcc-c++ libMySQL-devel libexpat-devel libgtkhtml3-devel libgtkmm2-devel libgtksourceview1-devel libglade-devel libgnome-devel
BuildRequires: liblua5-devel libncurses-devel libpcre-devel libreadline-devel libslang-devel libuuid-devel python-devel
BuildRequires: python-devel-static liblua5-devel-static desktop-file-utils

#BuildRequires:  libglade2-devel, gtkmm24-devel >= 2.6 , pcre-devel, mysql-devel >= 4.0
#BuildRequires:  openssl-devel, gtkhtml3-devel, desktop-file-utils, gettext
#BuildRequires:  mesa-libGLU-devel, python-devel, autoconf, automake
#BuildRequires:  libtool, expat-devel, readline-devel, perl-devel
#BuildRequires:  libgnomeprint22-devel, libgnome-devel
#BuildRequires:  java-1.6.0-openjdk-devel
#BuildRequires:  automake autoconf perl(XML::Parser)

Requires: mysql-administrator = %version-%release
Requires: mysql-query-browser = %version-%release

%description
GUI Tools for MySQL 5.0 is a suite of applications written for developing
and managing MySQL servers.

This package contains data files and libraries for MySQL GUI Tools.
Actual applications are in packages mysql-administrator, mysql-query-browser
and mysql-workbench

%package -n mysql-administrator
Summary: Administration tool for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-common = %version-%release

%description -n mysql-administrator
MySQL Administrator is a powerful graphical administration console that
enables you to easily administer your MySQL environment and gain
significantly better visibility into how your databases are operating.
MySQL Administrator now integrates database management and maintenance
into a single, seamless environment, with a clear and intuitive graphical
user interface.

This is MySQL Administrator.

%package -n mysql-query-browser
Summary: Query shell for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-common = %version-%release

%description -n mysql-query-browser
MySQL Query Browser is a GUI tool for executing SQL queries.
It will display the result in a list where you can edit its contents
and save. It has several auxiliar features to facilitate work, such
as query "bookmarking", query history, syntax highlighting and online
help.

Documentation: http://dev.mysql.com/doc/query-browser/en/

This is MySQL QueryBrowser.

%if %build_mt
%package -n mysql-migration-toolkit
Summary: Experimental database migration tool for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-common = %version-%release

%description -n mysql-migration-toolkit
MySQL Migration Toolkit is a framework for migrating databases from
various RDBMS to MySQL. The Linux version of the tool is a simpler,
text only version, but can be used to help migration of tables and data.
%endif

%package -n mysql-gui-common
Summary: Common data shared among the MySQL GUI Suites
Group: Development/Databases

%description -n mysql-gui-common
This package contains  glade files images and translations used by mysql tools
at runtime

%package -n mysql-gui-doc
Summary: Common data shared among the MySQL GUI Suites
Group: Development/Databases
BuildArch: noarch

%description -n mysql-gui-doc
This package contains  glade files images and translations used by mysql tools
at runtime


%prep
%setup -q
%patch0 -p1 -b .shellbang
%patch1 -p1 -b .loop
%patch2 -p0 -b .gcc43
%patch3 -p1 -b .sigc++
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

# rpmlint complains that the debuginfo packages have a bunch of files with wrong eol
# and executeable perms lets use a hammer and fix it
find . -name "*.h" -exec chmod 644 {} \;
find . -name "*.h" -exec sed -i 's/\r//' {} \;
find . -name "*.cc" -exec chmod 644 {} \;
find . -name "*.cc" -exec sed -i 's/\r//' {} \;
find . -name "*.c" -exec chmod 644 {} \;
find . -name "*.c" -exec sed -i 's/\r//' {} \;
find . -name "*.cpp" -exec chmod 644 {} \;
find . -name "*.cpp" -exec sed -i 's/\r//' {} \;

%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

%build
# gui-common
pushd  common
sh autogen.sh
%configure --enable-php-modules \
        --enable-python-modules \
        --enable-readline \
        --disable-java-modules \
        --disable-php-modules \
        --enable-grt --with-lua-libs=-L%_libdir
#%ifarch x86_64 ppc64 sparc64
#        --with-java-includes=/usr/lib/jvm/java-1.6.0-openjdk-1.6.0.0.%{_arch}/include
#%else
#        --with-java-includes=/usr/lib/jvm/java-1.6.0-openjdk-1.6.0.0/include
#%endif
%make_build
popd

%if %build_mt
# migration tool
cd ../mysql-migration-tool
env LD_LIBRARY_PATH="$LD_LIBRARY_PATH:%javalibdir" ./build_mt_script.sh
%endif

# administrator
pushd administrator
sh autogen.sh
%configure
%make_build
popd

# query-browser
pushd query-browser
sh autogen.sh --with-gtkhtml=%gtkhtml
%configure --with-gtkhtml=%gtkhtml
%make_build
popd

#NOCONFIGURE=1 sh ./autogen.sh

%install
pushd common
chmod 644 COPYING README
%makeinstall_std localedir=%buildroot%_datadir/locale
popd

pushd administrator
chmod 644 COPYING
%makeinstall_std localedir=%buildroot%_datadir/locale
popd

pushd query-browser
chmod 644 COPYING
%makeinstall_std localedir=%buildroot%_datadir/locale
popd

%if %build_mt
cd ../mysql-migration-tool
mkdir -p %buildroot%_libdir/mysql-gui/migration-toolkit-script/
cp -a mysql-migration-toolkit-script-*/* %buildroot%_libdir/mysql-gui/migration-toolkit-script/
%endif

# MySQL  use dos new line characters  that desktop-file-install doesn't like
# MySQL  also use dos new line endings in there documantation files rpmlint didn't like them
sed -i 's/\r//' %buildroot%_datadir/applications/MySQLAdministrator.desktop
sed -i 's/\r//' %buildroot%_datadir/applications/MySQLQueryBrowser.desktop
sed -i 's/\r//' administrator/COPYING common/COPYING common/README 
sed -i 's/\r//' query-browser/COPYING 

desktop-file-install --vendor=altlinux \
  --dir %buildroot%_datadir/applications \
  --add-category System \
  --add-category Application \
  --add-category X-ALTLinux \
  --delete-original \
  %buildroot%_datadir/applications/MySQLAdministrator.desktop

desktop-file-install --vendor=altlinux \
  --dir %buildroot%_datadir/applications \
  --add-category Development \
  --add-category Application \
  --add-category X-ALTLinux \
  --delete-original \
  %buildroot%_datadir/applications/MySQLQueryBrowser.desktop


%find_lang mysql-administrator
%find_lang mysql-query-browser


# copy docs
mkdir -p %buildroot%_docdir/mysql-gui-tools
tar xf %SOURCE1 -C %buildroot%_docdir/mysql-gui-tools
mv %buildroot%_docdir/%name/guibook-en.html-chapter/* %buildroot%_docdir/%name/
rmdir %buildroot%_docdir/%name/guibook-en.html-chapter

%files
%doc administrator/COPYING

%files -n mysql-administrator -f mysql-administrator.lang
%doc administrator/COPYING 
%_bindir/mabackup
%_bindir/mysql-administrator
%_bindir/mysql-administrator-bin
%_datadir/applications/altlinux-MySQLAdministrator.desktop
%_datadir/mysql-gui/MySQLIcon_Admin_*.png
%_datadir/mysql-gui/administrator

%files -n mysql-gui-common
%doc common/COPYING common/README
%dir %_datadir/mysql-gui
%_datadir/mysql-gui/common

%files -n mysql-query-browser -f mysql-query-browser.lang
%doc query-browser/COPYING 
%_bindir/mysql-query-browser*
%_datadir/applications/altlinux-MySQLQueryBrowser.desktop
%_datadir/mysql-gui/query-browser
%_datadir/mysql-gui/MySQLIcon_QueryBrowser_*.png

%if %build_mt
%files -n mysql-migration-toolkit
%_libdir/mysql-gui/migration-toolkit-script/
%_libdir/mysql-gui/libmyx_grt_java.so
%endif

%files -n mysql-gui-doc
%dir %_docdir/%name
%_docdir/%name


%changelog
* Sun Jan 31 2010 Evgeny Sinelnikov <sin@altlinux.ru> 5.0r17-alt0.M51.2
- Build for branch 5.1

* Sat Jan 30 2010 Evgeny Sinelnikov <sin@altlinux.ru> 5.0r17-alt2
- Fix DEFAULT_MY_CNF_PATH to /var/lib/mysql/my.cnf

* Sat Jan 30 2010 Evgeny Sinelnikov <sin@altlinux.ru> 5.0r17-alt1
- update to 5.0r17 from bazaar repos:
+ https://code.launchpad.net/mysql-gui-common
+ https://code.launchpad.net/mysql-administrator
+ https://code.launchpad.net/mysql-querybrowser
+ https://code.launchpad.net/mysql-migrationtool

* Thu Jan 28 2010 Evgeny Sinelnikov <sin@altlinux.ru> 5.0r14-alt1
- update to 5.0r14 with patches from Fedora

* Sun Jan 18 2009 Vitaly Lipatov <lav@altlinux.ru> 5.0r12a-alt5
- build with grt, lua, python-modules
- add mysql-workbench package build (todo: test lua related problem)
- update buildreqs

* Wed Nov 05 2008 Vitaly Lipatov <lav@altlinux.ru> 5.0r12a-alt4
- fix build with gcc 4.3
- fix build with external libgtksourceview 1
- update buildreq

* Tue Apr 15 2008 Vitaly Lipatov <lav@altlinux.ru> 5.0r12a-alt3
- fix build with new sigc (SigC::Connection was dropped)

* Sat Mar 08 2008 Vitaly Lipatov <lav@altlinux.ru> 5.0r12a-alt2
- fix "Error applying user changes" due new user creating

* Sun Jan 20 2008 Vitaly Lipatov <lav@altlinux.ru> 5.0r12a-alt1
- rewrote spec, build from current SVN trunk
- add patch against freeze bug

* Tue Oct 09 2007 Vitaly Lipatov <lav@altlinux.ru> 5.0r12-alt2
- rebuild with new libgtkhtml 3.14
- add Url

* Fri Jul 20 2007 Vitaly Lipatov <lav@altlinux.ru> 5.0r12-alt1
- initial build for ALT Linux Sisyphus

